<?php
class ux_tslib_menu extends tslib_menu {

/**
	 * Creates the URL, target and onclick values for the menu item link. Returns them in an array as key/value pairs for <A>-tag attributes
	 * This function doesn't care about the url, because if we let the url be redirected, it will be logged in the stat!!!
	 *
	 * @param	integer		Pointer to a key in the $this->menuArr array where the value for that key represents the menu item we are linking to (page record)
	 * @param	string		Alternative target
	 * @param	integer		Alternative type
	 * @return	array		Returns an array with A-tag attributes as key/value pairs (HREF, TARGET and onClick)
	 * @access private
	 * @author	Alexander Bohndorf <bohndorf@sitegeist.de>	 
	 */
	function link($key,$altTarget='',$typeOverride='') {
				// Mount points:
		$MP_var = $this->getMPvar($key);
		$MP_params = $MP_var ? '&MP='.rawurlencode($MP_var) : '';

			// Setting override ID
		if ($this->mconf['overrideId'] || $this->menuArr[$key]['overrideId'])	{
			$overrideArray = array();
				// If a user script returned the value overrideId in the menu array we use that as page id
			$overrideArray['uid'] = $this->mconf['overrideId']?$this->mconf['overrideId']:$this->menuArr[$key]['overrideId'];
			$overrideArray['alias'] = '';
			$MP_params = '';	// clear MP parameters since ID was changed.
		} else {
			$overrideArray='';
		}

			// Setting main target:
		$mainTarget = $altTarget ? $altTarget : $this->mconf['target'];

			// Creating link:
		if ($this->mconf['collapse'] && $this->isActive($this->menuArr[$key]['uid'], $this->getMPvar($key)))	{
			$thePage = $this->sys_page->getPage($this->menuArr[$key]['pid']);
			$LD = $this->tmpl->linkData($thePage,$mainTarget,'','',$overrideArray, $this->mconf['addParams'].$MP_params.$this->menuArr[$key]['_ADD_GETVARS'], $typeOverride);
		} else {
			//$LD = $this->tmpl->linkData($this->menuArr[$key],$mainTarget,'','',$overrideArray, $this->mconf['addParams'].$MP_params.$this->menuArr[$key]['_ADD_GETVARS'], $typeOverride);
			//--- Patch für Shortcuts, die direkt auf Zielseite verlinken sollen statt Redirect (Zeile darüber wegen Patch auskommentiert)
			switch($this->menuArr[$key]['doktype'])
			{
			   case 4: // Shortcut
			     $thePage = $this->sys_page->getPage($this->menuArr[$key]['shortcut']);
			     if($this->menuArr[$key]['target']) $mainTarget = $this->menuArr[$key]['target'];
			     break;
			   default:
			     $thePage = $this->menuArr[$key];
      }
			$LD = $this->tmpl->linkData($thePage,$mainTarget,'','',$overrideArray, $this->mconf['addParams'].$MP_params.$this->menuArr[$key]['_ADD_GETVARS'], $typeOverride);
			//--- Ende Patch
		}

			// Manipulation in case of access restricted pages:
		$this->changeLinksForAccessRestrictedPages($LD,$this->menuArr[$key],$mainTarget,$typeOverride);

			// Overriding URL / Target if set to do so:
		if ($this->menuArr[$key]['_OVERRIDE_HREF'])	{
			$LD['totalURL'] = $this->menuArr[$key]['_OVERRIDE_HREF'];
			if ($this->menuArr[$key]['_OVERRIDE_TARGET'])	$LD['target'] = $this->menuArr[$key]['_OVERRIDE_TARGET'];
		}

			// OnClick open in windows.
		$onClick='';
		if ($this->mconf['JSWindow'])	{
			$conf=$this->mconf['JSWindow.'];
			$url=$LD['totalURL'];
			$LD['totalURL'] = '#';
			$onClick= 'openPic(\''.$GLOBALS['TSFE']->baseUrlWrap($url).'\',\''.($conf['newWindow']?md5($url):'theNewPage').'\',\''.$conf['params'].'\'); return false;';
			$GLOBALS['TSFE']->setJS('openPic');
		}

			// out:
		$list = array();
		$list['HREF'] = strlen($LD['totalURL']) ? $LD['totalURL'] : $GLOBALS['TSFE']->baseUrl;	// Added this check: What it does is to enter the baseUrl (if set, which it should for "realurl" based sites) as URL if the calculated value is empty. The problem is that no link is generated with a blank URL and blank URLs might appear when the realurl encoding is used and a link to the frontpage is generated.
		$list['TARGET'] = $LD['target'];
		$list['onClick'] = $onClick;
		return $list;

	}
}

class ux_tslib_tmenu extends tslib_tmenu {
	function link($key,$altTarget='',$typeOverride='') {
    return(ux_tslib_menu::link($key,$altTarget,$typeOverride));
	}
}

class ux_tslib_gmenu extends tslib_gmenu {
	function link($key,$altTarget='',$typeOverride='') {
    return(ux_tslib_menu::link($key,$altTarget,$typeOverride));
	}
}
class ux_tslib_imgmenu extends tslib_imgmenu {
	function link($key,$altTarget='',$typeOverride='') {
    return(ux_tslib_menu::link($key,$altTarget,$typeOverride));
	}
}
class ux_tslib_jsmenu extends tslib_jsmenu {
	function link($key,$altTarget='',$typeOverride='') {
    return(ux_tslib_menu::link($key,$altTarget,$typeOverride));
	}
}

?>
